// 2022.06.02 Takeshi Yoneki

use winapi::shared::ntdef::NULL;
use winapi::um::minwinbase::SYSTEMTIME;
use winapi::shared::minwindef::FILETIME;
use winapi::um::timezoneapi::SystemTimeToFileTime;
use winapi::um::fileapi::LocalFileTimeToFileTime;
use winapi::um::fileapi::CreateFileW;
use winapi::um::fileapi::OPEN_EXISTING;
//use winapi::um::fileapi::OPEN_ALWAYS;
use winapi::um::winnt::FILE_WRITE_ATTRIBUTES;
use winapi::um::winnt::GENERIC_READ;
use winapi::um::winnt::GENERIC_WRITE;
use winapi::um::winnt::FILE_ATTRIBUTE_NORMAL;
use winapi::um::minwinbase::SECURITY_ATTRIBUTES;
use winapi::um::fileapi::SetFileTime;
use winapi::um::handleapi::CloseHandle;
use winapi::um::handleapi::INVALID_HANDLE_VALUE;
use winapi::um::winnls::CP_UTF8;
use winapi::um::stringapiset::MultiByteToWideChar;

pub fn set_file_mtime(path_u8: &str, year:u16, month: u16, day: u16, hour: u16, minute: u16, second: u16) -> bool {
    unsafe {
        let st = SYSTEMTIME { wYear: year, wMonth: month, wDayOfWeek: 0, wDay: day, wHour: hour, wMinute: minute, wSecond: second, wMilliseconds: 0};
        let mut lft = FILETIME {dwLowDateTime: 0, dwHighDateTime: 0};
        let b1 = SystemTimeToFileTime(&st, &mut lft);
        let mut uft = FILETIME {dwLowDateTime: 0, dwHighDateTime: 0};
        let b2 = LocalFileTimeToFileTime(&lft, &mut uft);
        let szu8 = path_u8.len() as i32;
        let szw = MultiByteToWideChar(CP_UTF8, 0, path_u8.as_ptr() as *const i8, szu8, NULL as *mut u16, 0);
        let mut path_u16: Vec<u16> = vec![0; (szw + 1) as usize];
        let _ = MultiByteToWideChar(CP_UTF8, 0, path_u8.as_ptr() as *const i8, szu8, path_u16.as_mut_ptr(), szw);
        let h = CreateFileW(path_u16.as_ptr(), GENERIC_READ | GENERIC_WRITE | FILE_WRITE_ATTRIBUTES, 0, NULL as *mut SECURITY_ATTRIBUTES, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
        if h != INVALID_HANDLE_VALUE {
            let b3 = SetFileTime(h, NULL as *const FILETIME, NULL as *const FILETIME, &uft);
            CloseHandle(h);
            b3 != 0
        }
        else {
            false
        }
    }
}
